% Deguang Yu - CIS 601 - Home work #8
%------------------------------------

clear all;
close all;

f = imread('flower.jpg');
figure; imshow(f);

%get data
R=f(:,:,1);
G=f(:,:,2);
B=f(:,:,3);

%reshape the image to have one column for each color space
data=[];
data=[data reshape(R, (size(R,1)*size(R,2)),1)];
data=[data reshape(G, (size(G,1)*size(G,2)),1)];
data=[data reshape(B, (size(B,1)*size(B,2)),1)];
data=double(data);

%get keans
IDX = kmeans(data, 3);

R_total=[];
G_total=[];
B_total=[];

for i=1:6
    R_total(1,i)=0;
    G_total(1,i)=0;
    B_total(1,i)=0;    
end

for i=1:3
    for j=1:size(data,1)
        if IDX(j,1)==1
            R_total(1,1)=R_total(1,1)+1;
            R_total(1,2)=R_total(1,2)+data(j,1);

            G_total(1,1)=G_total(1,1)+1;
            G_total(1,2)=G_total(1,2)+data(j,2);            
            
            B_total(1,1)=B_total(1,1)+1;
            B_total(1,2)=B_total(1,2)+data(j,3);            
        elseif IDX(j,1)==2
            R_total(1,3)=R_total(1,3)+1;
            R_total(1,4)=R_total(1,4)+data(j,1);

            G_total(1,3)=G_total(1,3)+1;
            G_total(1,4)=G_total(1,4)+data(j,2);            
            
            B_total(1,3)=B_total(1,3)+1;
            B_total(1,4)=B_total(1,4)+data(j,3);              
        else
            R_total(1,5)=R_total(1,5)+1;
            R_total(1,6)=R_total(1,6)+data(j,1);

            G_total(1,5)=G_total(1,5)+1;
            G_total(1,6)=G_total(1,6)+data(j,2);            
            
            B_total(1,5)=B_total(1,5)+1;
            B_total(1,6)=B_total(1,6)+data(j,3); 
        end            
    end                
end    

for i=1:3
    Rf_total(1,i)=R_total(1,i*2)/R_total(1,i*2-1);
    Gf_total(1,i)=G_total(1,i*2)/G_total(1,i*2-1);
    Bf_total(1,i)=B_total(1,i*2)/B_total(1,i*2-1);    
end    

%resign average value to each categary
for i=1:3
    for j=1:size(data,1)
        if IDX(j,1)==1
            data(j,1)=Rf_total(1,1);
            data(j,2)=Gf_total(1,1);
            data(j,3)=Bf_total(1,1);
        elseif IDX(j,1)==2
            data(j,1)=Rf_total(1,2);
            data(j,2)=Gf_total(1,2);
            data(j,3)=Bf_total(1,2);
        else
            data(j,1)=Rf_total(1,3);
            data(j,2)=Gf_total(1,3);
            data(j,3)=Bf_total(1,3);
        end            
    end                
end    

%reshape columns back to the original image
t(:,:,1)=reshape(data(:,1), size(R,1),size(R,2));
t(:,:,2)=reshape(data(:,2), size(G,1),size(G,2));
t(:,:,3)=reshape(data(:,3), size(B,1),size(B,2));

t=uint8(t);
figure; imshow(t);